; Colecovision - Sprite Tests, by F-Cycles

SPRITE_GEN_RAM_ADR: equ $7080

	fname "multi_sprites.rom"
	cpu z80
	org $8000
	dw $aa55,0,0,0,0,Start
	reti ; RST 08h
	nop
	reti ; RST 10h
	nop
	reti ; RST 18h
	nop
	reti ; RST 20h
	nop
	reti ; RST 28h
	nop
	reti ; RST 30h
	nop
	reti ; RST 38h IRQ Interrupt
	nop

	; --- NMI ROUTINE ---
	ld de,$3000	; --- copy to 3000 sprite attribute ---
	ld hl,SpriteAttrib
	ld bc,64
	call $1fdf ; WRITE_VRAM
	in a,($bf)

	ld a, $00
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
    ld c, $00
lp_b:
	ld a, c
	inc c
	ld a, $15
lp_a:
    dec a
	jp nz, lp_a
    nop	
	nop
	add a, 1
	add a, 1
	add a, 1
	ld a, c
	sub a, $50
	jp nz, lp_b
	
	ld a, $00
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
	ld de,$3000	; --- copy to 3000 sprite attribute ---
	ld hl,SpriteAttribEx
	ld bc,64
	call $1fdf ; WRITE_VRAM
	in a,($bf)
	
	retn

Start:
	call $1f85 ; MODE_1
	call $1fd6 ; TURN_OFF_SOUND
	; Clear VRAM
	ld hl,0
	ld de,$4000
	xor a
	call $1f82 ; FILL_VRAM

	ld c, $01
	ld de,$3800	; --- copy to 3800 generated sprite ---
gen_sprites:
	push bc
	push de
	
	call GenerateSprite

	pop  de
	push de
	ld hl,SPRITE_GEN_RAM_ADR
	ld bc,32
	call $1fdf ; WRITE_VRAM
	pop de
	pop bc
	inc c
	ld hl, $20
	add hl, de
	push hl
	pop de
	ld a, c
	sub a, $49
	jr z, finish_gen_sprites
	ld a, c
	and a, $0f
	sub a, 10
	jr nz, gen_sprites
	ld a, c
	and a, $f0
	add a, $10
	ld c, a
	jr nz, gen_sprites

finish_gen_sprites:	
	;	in a,($bf)

	ld de,$3000	; --- copy to 3000 sprite attribute ---
	ld hl,SpriteAttrib
	ld bc,128
	call $1fdf ; WRITE_VRAM
	in a,($bf)
	
	ld de,$3000	; --- copy to 3000 sprite attribute ---
	ld hl,SpriteAttribEx
	ld bc,64
	call $1fdf ; WRITE_VRAM
	in a,($bf)
	
	; Turn On Display
	ld bc,$01e2
	call $1fd9 ; WRITE_REGISTER
	in a,($bf)
	
	ld bc,$0607
	call $1fd9 ; WRITE_REGISTER
	in a,($bf)
	
	ld bc,$0560
	call $1fd9 ; WRITE_REGISTER
	in a,($bf)
	
TheEnd:
	halt
	jp TheEnd

SpriteAttrib:
		db $00-1, $20, $00, $0f ; y=0, x =0x40, sprite data=0, color = 6
		db $00-1, $40, $04, $0e ; y=0, x =0x40, sprite data=0, color = 6
		db $00-1, $60, $08, $0d ; y=0, x =0x40, sprite data=0, color = 6
		db $00-1, $80, $0C, $0c ; y=0, x =0x40, sprite data=0, color = 6

		db $10-1, $24, $10, $0e ; y=0, x =0x40, sprite data=0, color = 6
		db $10-1, $44, $14, $0d ; y=0, x =0x40, sprite data=0, color = 6
		db $10-1, $64, $18, $0c ; y=0, x =0x40, sprite data=0, color = 6
		db $10-1, $84, $1C, $0b ; y=0, x =0x40, sprite data=0, color = 6

		db $20-1, $28, $20, $0d ; y=0, x =0x40, sprite data=0, color = 6
		db $20-1, $48, $24, $0c ; y=0, x =0x40, sprite data=0, color = 6
		db $20-1, $68, $28, $0b ; y=0, x =0x40, sprite data=0, color = 6
		db $20-1, $88, $2C, $0a ; y=0, x =0x40, sprite data=0, color = 6

		db $30-1, $2C, $30, $0c ; y=0, x =0x40, sprite data=0, color = 6
		db $30-1, $4C, $34, $0b ; y=0, x =0x40, sprite data=0, color = 6
		db $30-1, $6C, $38, $0a ; y=0, x =0x40, sprite data=0, color = 6
		db $30-1, $8C, $3C, $09 ; y=0, x =0x40, sprite data=0, color = 6

		db $40-1, $30, $40, $0b ; y=0, x =0x40, sprite data=0, color = 6
		db $40-1, $50, $44, $0a ; y=0, x =0x40, sprite data=0, color = 6
		db $40-1, $70, $48, $09 ; y=0, x =0x40, sprite data=0, color = 6
		db $40-1, $90, $4C, $08 ; y=0, x =0x40, sprite data=0, color = 6

		db $50-1, $34, $50, $0a ; y=0, x =0x40, sprite data=0, color = 6
		db $50-1, $54, $54, $09 ; y=0, x =0x40, sprite data=0, color = 6
		db $50-1, $74, $58, $08 ; y=0, x =0x40, sprite data=0, color = 6
		db $50-1, $94, $5C, $07 ; y=0, x =0x40, sprite data=0, color = 6

		db $60-1, $38, $60, $09 ; y=0, x =0x40, sprite data=0, color = 6
		db $60-1, $58, $64, $08 ; y=0, x =0x40, sprite data=0, color = 6
		db $60-1, $78, $68, $07 ; y=0, x =0x40, sprite data=0, color = 6
		db $60-1, $98, $6C, $06 ; y=0, x =0x40, sprite data=0, color = 6

		db $70-1, $3C, $70, $08 ; y=0, x =0x40, sprite data=0, color = 6
		db $70-1, $5C, $74, $07 ; y=0, x =0x40, sprite data=0, color = 6
		db $70-1, $7C, $78, $06 ; y=0, x =0x40, sprite data=0, color = 6
		db $70-1, $9C, $7C, $05 ; y=0, x =0x40, sprite data=0, color = 6

SpriteAttribEx:
		db $80-1, $40, $80, $07 ; y=0, x =0x40, sprite data=0, color = 6
		db $80-1, $60, $84, $06 ; y=0, x =0x40, sprite data=0, color = 6
		db $80-1, $80, $88, $05 ; y=0, x =0x40, sprite data=0, color = 6
		db $80-1, $A0, $8C, $04 ; y=0, x =0x40, sprite data=0, color = 6

		db $90-1, $44, $90, $06 ; y=0, x =0x40, sprite data=0, color = 6
		db $90-1, $64, $94, $05 ; y=0, x =0x40, sprite data=0, color = 6
		db $90-1, $84, $98, $04 ; y=0, x =0x40, sprite data=0, color = 6
		db $90-1, $A4, $9C, $03 ; y=0, x =0x40, sprite data=0, color = 6
	
		db $A0-1, $48, $A0, $05 ; y=0, x =0x40, sprite data=0, color = 6
		db $A0-1, $68, $A4, $04 ; y=0, x =0x40, sprite data=0, color = 6
		db $A0-1, $88, $A8, $03 ; y=0, x =0x40, sprite data=0, color = 6
		db $A0-1, $A8, $AC, $02 ; y=0, x =0x40, sprite data=0, color = 6
		
		db $B0-1, $4C, $B0, $04 ; y=0, x =0x40, sprite data=0, color = 6
		db $B0-1, $6C, $B4, $03 ; y=0, x =0x40, sprite data=0, color = 6
		db $B0-1, $8C, $B8, $02 ; y=0, x =0x40, sprite data=0, color = 6
		db $B0-1, $AC, $BC, $0f ; y=0, x =0x40, sprite data=0, color = 6
		
; Function: write sprite background & number to ram.
; c = number 0x10 = 10
GenerateSprite:
		ld de, SpriteBackground
;		ld de, SpriteBackground_TestColorOnCRT
		ld hl, SPRITE_GEN_RAM_ADR
		ld b, 32
copy_gen_sprite:		
		ld a, (de)
		ld (hl), a
		inc de
		inc hl
		dec b
		ld a, b
		jr nz, copy_gen_sprite	

		ld hl, SpriteNumbers
		ld a, c
		and $f0
		sra a
		ld e, a
		ld d, 0
		add hl, de
		push hl
		ld hl, SPRITE_GEN_RAM_ADR
		ld de, 4
		add hl, de
		pop de
		ld b, 7
copy_high_digit:
		ld a, (de)
		sra a
		xor $ff
		and (hl)
		ld (hl), a
		inc de
		inc hl
		dec b
		ld a, b
		jr nz, copy_high_digit

		ld hl, SpriteNumbers
		ld a, c
		and $0f
		sla a
		sla a
		sla a
		ld e, a
		ld d, 0
		add hl, de
		push hl
		ld hl, SPRITE_GEN_RAM_ADR
		ld de, 20
		add hl, de
		pop de
		ld b, 7
copy_low_digit:
		ld a, (de)
		sla a
		xor $ff
		and (hl)
		ld (hl), a
		inc de
		inc hl
		dec b
		ld a, b
		jr nz, copy_low_digit
		retn

; Function: copy ram to vram.

;SpriteBackground_TestColorOnCRT:
;    db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
;    db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
;    db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
;    db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
SpriteBackground:
    db %00000111
    db %00011111
    db %00111111
    db %01111111
    db %01111111
    db %11111111
    db %11111111
    db %11111111

    db %11111111
    db %11111111
    db %11111111
    db %01111111
    db %01111111
    db %00111111
    db %00011111
    db %00000111

    db %11100000
    db %11111000
    db %11111100
    db %11111110
    db %11111110
    db %11111111
    db %11111111
    db %11111111

    db %11111111
    db %11111111
    db %11111111
    db %11111110
    db %11111110
    db %11111100
    db %11111000
    db %11100000
	
SpriteNumbers:
    db %00111100 ; 0
    db %00100100
    db %00100100
    db %00100100
    db %00100100
    db %00100100
    db %00111100
    db %00000000
	
    db %00000100 ; 1
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000000

    db %00111100 ; 2
    db %00000100
    db %00000100
    db %00111100
    db %00100000
    db %00100000
    db %00111100
    db %00000000

    db %00111100 ; 3
    db %00000100
    db %00000100
    db %00111100
    db %00000100
    db %00000100
    db %00111100
    db %00000000

    db %00100100 ; 4
    db %00100100
    db %00100100
    db %00111100
    db %00000100
    db %00000100
    db %00000100
    db %00000000
	
    db %00111100 ; 5
    db %00100000
    db %00100000
    db %00111100
    db %00000100
    db %00000100
    db %00111100
    db %00000000
	
    db %00111100 ; 6
    db %00100000
    db %00100000
    db %00111100
    db %00100100
    db %00100100
    db %00111100
    db %00000000
	
    db %00111100 ; 7
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000100
    db %00000000

    db %00111100 ; 8
    db %00100100
    db %00100100
    db %00111100
    db %00100100
    db %00100100
    db %00111100
    db %00000000

    db %00111100 ; 9
    db %00100100
    db %00100100
    db %00111100
    db %00000100
    db %00000100
    db %00111100
    db %00000000
	
; EOF
