; Colecovision - NMI Tests, by F-Cycles

NB_SPRITE: equ 1

	fname "nmi_test.rom"
	cpu z80
	org $8000
	dw $aa55,0,0,0,0,Start
	reti ; RST 08h
	nop
	reti ; RST 10h
	nop
	reti ; RST 18h
	nop
	reti ; RST 20h
	nop
	reti ; RST 28h
	nop
	reti ; RST 30h
	nop
	reti ; RST 38h IRQ Interrupt
	nop

	; --- NMI ROUTINE ---
    ld c, $02
lp_b:
	ld a, c
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.

	inc c
	ld a, $15
lp_a:
    dec a
	jp nz, lp_a
    nop	
	nop
	add a, 1
	add a, 1
	add a, 1
	ld a, c
	sub a, $50
	jp nz, lp_b
	
    xor a, a
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
	; --- extra instruction to stabilize on the real hardware ---
;	add a, 1
;	add a, 1
    ; --- but not on the Blue MSX (	v2.8.2 ) ---
    retn

	
	
Start:
	call $1f85 ; MODE_1
	call $1fd6 ; TURN_OFF_SOUND
	; Clear VRAM
	ld hl,0
	ld de,$4000
	xor a
	call $1f82 ; FILL_VRAM

	; Turn On Display
	ld bc,$01e2
	call $1fd9 ; WRITE_REGISTER

;    ld a, $01
;    out ($bf), a
;    ld a, $80
;    out ($bf), a ; set register 0 to $1, enable NMI
;    in a,($bf) ; required to re-init to data.
;	ei	
TheEnd:
    halt       ; the CPU keep doing nop (4 cycles)
	jp TheEnd


; EOF
