; Colecovision - MultiColor, by F-Cycles

NB_SPRITE: equ 1

	fname "vm_multicolor.rom"
	cpu z80
	org $8000
	dw $aa55,0,$7000,0,0,Start
	reti ; RST 08h
	nop
	reti ; RST 10h
	nop
	reti ; RST 18h
	nop
	reti ; RST 20h
	nop
	reti ; RST 28h
	nop
	reti ; RST 30h
	nop
	reti ; RST 38h IRQ Interrupt
	nop

	; --- NMI ROUTINE ---
	ld a, $00
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
	ld de, $0014
lp_pre_a:
	call Delay_long
	inc de
	bit 5, e
	jr z, lp_pre_a
	nop
	nop
;	nop
;	nop
;	bit 5, e
	ld de, $0000
lp_a:
	ld   bc,$0401 ; Char set start at $0800
	call $1fd9
    in a,($bf)

	call Delay_Long

	ld   bc,$0403 ; Char set start at $0800
	call $1fd9
    in a,($bf)

	call Delay_Long

	ld   bc,$0404 ; Char set start at $0800
	call $1fd9
    in a,($bf)

	call Delay_Long

	ld   bc,$0402 ; Char set start at $0800
	call $1fd9
    in a,($bf)

	nop
	dec bc
	cp (hl)
;	nop
;	nop
;	bit 3, c
	bit 3, d
	bit 3, d
	
	inc de
	bit 6, e
	jr z, lp_a
		
    xor a, a
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
	; --- extra instruction to stabilize on the real hardware ---
	add a, 1
	add a, 1
    ; --- but not on the Blue MSX (	v2.8.2 ) ---
    retn
Delay_Long:
	nop
	bit 3, c
	ld bc, ($8000)
	retn
Start:
	call $1f85 ; MODE_1
	call $1fd6 ; TURN_OFF_SOUND
	; Clear VRAM
	ld hl,0
	ld de,$4000
	xor a
	call $1f82 ; FILL_VRAM
	
	call SetupMultiColorName
	call SetupMultiColorPattern

	call Display_VMode_MultiColor
	
TheEnd:
	halt
	jp TheEnd

; --- Setup MultiColor ---
; so colors decribe within the pattern will be 2x8 pixels.
	; 0 1 2 3 ... 31
	; 0 1 2 3 ... 31
	; 0 1 2 3 ... 31
	; 0 1 2 3 ... 31

	; 32 33 34 35 ... 63
	; 32 33 34 35 ... 63
	; ...
FillLine:	
		ld a, $00
fill_name_line:
		or b
		out ($be), a
		and a, $1f
		inc a
		bit 5, a ; 54 3210
		jr z, fill_name_line
		retn
	
SetupMultiColorName:
        ld a,$00	; (LSB)
        out ($bf),a
        ld a,$40    ; $0000 | $4000 = $00 $40 (MSB)
        out ($bf),a
		
		ld b, $00	
fill_color_name:		
		call FillLine
		call FillLine
		call FillLine
		call FillLine
		ld a, b
		add a, $20
		ld b, a
		sub a, $00
		jr nz, fill_color_name
		retn


SetupMultiColorPattern:
        ld a,$00	; (LSB)
        out ($bf),a
        ld a,$48    ; $0800 | $4800 = $00 $48 (MSB)
        out ($bf),a

		ld bc, $0000
		ld a,$00
loop_pattern:		
		out ($be), a
		add a, $F1
		inc bc
		bit 4, b
		jr z, no_adjust		
		bit 0, c
		jr z, no_adjust		
		add a, $53
no_adjust:
		bit 2, b
		jr z, no_adjust2		
		bit 0, c
		jr z, no_adjust2		
		bit 1, c
		jr z, no_adjust2		
		bit 2, c
		jr z, no_adjust2		
		bit 3, c
		jr z, no_adjust2		
		bit 4, c
		jr z, no_adjust2		
		bit 5, c
		jr z, no_adjust2		
		bit 6, c
		jr z, no_adjust2		
		bit 7, c
		jr z, no_adjust2		
		add a, $37
no_adjust2:
		bit 5, b
		jr z, loop_pattern		
		retn

Display_VMode_MultiColor:
	ld   bc,$0000
	call $1fd9
    in a,($bf)
	ld   bc,$01EA ; Text Mode
	call $1fd9
    in a,($bf)
	
	ld   bc,$0200 ; text start at $0000
	call $1fd9
    in a,($bf)
	
	ld   bc,$0401 ; Char set start at $0800
	call $1fd9
    in a,($bf)
	
	ld   bc,$0700
	call $1fd9
    in a,($bf)		
	retn
; EOF
