; Colecovision - Video Modes Tests, by F-Cycles

INIT_TABLE: equ $1fb8
LOAD_ASCII: equ $1f7f
ADJ_LEN: equ $7080
ADJ_LEN_DIR: equ $7081
ADJ_LEN_FRAME: equ $7082

	fname "vm_text.rom"
	cpu z80
	org $8000
	dw $aa55,0,$7000,0,0,Start
	reti ; RST 08h
	nop
	reti ; RST 10h
	nop
	reti ; RST 18h
	nop
	reti ; RST 20h
	nop
	reti ; RST 28h
	nop
	reti ; RST 30h
	nop
	reti ; RST 38h IRQ Interrupt
	nop

	; --- NMI ROUTINE ---
	ld   bc,$0401 ; Char set start at $0800
	call $1fd9
    in a,($bf)
	
    ld c, $14
lp_b:
	ld a, c
	add a, $10	
	ld c, a
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	ld a, (ADJ_LEN)
lp_a:
    dec a
	jp nz, lp_a
    nop	
	nop
	add a, 1
	add a, 1
	add a, 1
	ld a, c
	sub a, $f4
	jp nz, lp_b
	
    ld a, $f5
    out ($bf), a
    ld a, $87
    out ($bf), a ; set register 0 to $1, enable NMI
    in a,($bf) ; required to re-init to data.
	
	ld   bc,$0402 ; Char set start at $0800
	call $1fd9
    in a,($bf)
	
	ld a, (ADJ_LEN_FRAME)
	sub a, 0
	jr z, adj_len_fr
	dec a
	ld (ADJ_LEN_FRAME), a
	retn
adj_len_fr:
	ld a, 08
	ld (ADJ_LEN_FRAME), a
	ld a, (ADJ_LEN_DIR)
	sub a, 0
	jr z, dec_adj_len
	ld a, (ADJ_LEN)
	inc a
	ld (ADJ_LEN), a
	sub a, $d8
	jr nz, skip_reset_adj_len
	ld a, $0
	ld (ADJ_LEN_DIR), a
	retn
dec_adj_len:
	ld a, (ADJ_LEN)
	dec a
	ld (ADJ_LEN), a
	sub a, $32
	jr nz, skip_reset_adj_len
	ld a, $1
	ld (ADJ_LEN_DIR), a
	retn
	
skip_reset_adj_len:
    retn

Start:
	call $1f85 ; MODE_1
	call $1fd6 ; TURN_OFF_SOUND
	; Clear VRAM
	ld hl,0
	ld de,$4000
	xor a
	call $1f82 ; FILL_VRAM

	; Turn On Display
	ld bc,$01c2
	call $1fd9 ; WRITE_REGISTER
    in a,($bf)

	ld a, $a0
	ld (ADJ_LEN), a
	ld a, 0
	ld (ADJ_LEN_DIR), a
	ld (ADJ_LEN_FRAME), a
	call Init_VModeText
	call Display_VMode_Text

LoopForever:
	halt
	jp LoopForever

Init_VModeText:	
	; --- Copy Text Screen at $0000 ---
	ld hl,$0000
cpy_text_start_over:
	ld a, $10
cpy_text:	
	push af
	push hl
	ld de,$1
	call $1f82 ; FILL_VRAM
	pop hl
	ld a, h
	sub a, $04
	jr z, finish_cpy_text
	pop af
	inc hl
	inc a
	sub a, $cf
	jr z, cpy_text_start_over
	add a, $cf
	jr cpy_text
	
finish_cpy_text:
    pop af
	; --- Copy Char set at $0800 ---
	ld a, $00
	ld ($73F8),a
	ld a, $08
	ld ($73F9),a
	call INIT_TABLE
	call LOAD_ASCII

	; Load Rom at $1000 (test 2nd charset)
	ld de,$1000
	ld hl,$13C3
	ld bc,2048
	call $1fdf ; WRITE_VRAM
	retn
	
Display_VMode_Text:
	ld   bc,$0000
	call $1fd9
    in a,($bf)
	ld   bc,$01f2 ; Text Mode
	call $1fd9
    in a,($bf)
	
	ld   bc,$0200 ; text start at $0000
	call $1fd9
    in a,($bf)
	
	ld   bc,$0401 ; Char set start at $0800
	call $1fd9
    in a,($bf)
	
	ld   bc,$07f4
	call $1fd9
    in a,($bf)		
	retn

; EOF
